import unittest, main

class TestDirs(unittest.TestCase):
    def setUp(self):
        self.right=[1,0]
        self.left=[-1,0]
        self.up=[0,1]
        self.down=[0,-1]
        self.dirs=([0,1],[1,0],[0,-1],[-1,0])        
        
    def testright(self):
        self.assertEqual(self.dirs[main.right(self.up)],self.right)
        self.assertEqual(self.dirs[main.right(self.right)],self.down)
        self.assertEqual(self.dirs[main.right(self.down)],self.left)
        self.assertEqual(self.dirs[main.right(self.left)],self.up)
    def teststraight(self):
        self.assertEqual(self.dirs[main.straight(self.up)],self.up)
        self.assertEqual(self.dirs[main.straight(self.down)],self.down)
        self.assertEqual(self.dirs[main.straight(self.left)],self.left)
        self.assertEqual(self.dirs[main.straight(self.right)],self.right)



class TestNewDirection(unittest.TestCase):
    
    def setUp(self):
        #corners
        self.d2l=self.r2u=main.conveyor()
        self.r2u.ends=[1,0,0,1]
        self.r2u.type="corner"
        self.d2r=self.l2u=main.conveyor()
        self.l2u.ends=[1,1,0,0]
        self.l2u.type="corner"
        self.l2d=self.u2r=main.conveyor()
        self.u2r.ends=[0,1,1,0]
        self.u2r.type="corner"
        self.u2l=self.r2d=main.conveyor()
        self.r2d.ends=[0,0,1,1]
        self.r2d.type="corner"
        
        
        self.r2r=self.l2l=main.conveyor()
        self.r2r.ends=[0,1,0,1]
        self.d2d=self.u2u=main.conveyor()
        self.d2d.ends=[1,0,1,0]
        
        self.right=[1,0]
        self.left=[-1,0]
        self.up=[0,1]
        self.down=[0,-1]

    def teststraight(self):
        self.assertEqual(main.newdirection(self.r2r,self.right),self.right)
        self.assertEqual(main.newdirection(self.r2r,self.left),self.left)
        self.assertEqual(main.newdirection(self.u2u,self.up),self.up)
        self.assertEqual(main.newdirection(self.u2u,self.down),self.down)
        
       
    def testcorner(self):
        self.assertEqual(main.newdirection(self.d2l,self.down),self.left)
        self.assertEqual(main.newdirection(self.r2u,self.right),self.up)
        self.assertEqual(main.newdirection(self.d2r,self.down),self.right)
        self.assertEqual(main.newdirection(self.l2u,self.left),self.up)
        self.assertEqual(main.newdirection(self.l2d,self.left),self.down)
        self.assertEqual(main.newdirection(self.u2r,self.up),self.right)
        self.assertEqual(main.newdirection(self.u2l,self.up),self.left)
        self.assertEqual(main.newdirection(self.r2d,self.right),self.down)
        
        
class TestConnected(unittest.TestCase):
    def setUp(self):
        self.leftside=main.conveyor()
        self.rightside=main.conveyor()
        self.leftside.ends=(0,1,0,1)
        self.rightside.ends=(1,0,0,1)
        self.downside=main.conveyor()
        self.upside=main.conveyor()
        self.downside.ends=(1,0,1,0)
        self.upside.ends=(0,1,1,0)
        
    def testLineToCorner(self):
        self.assertEqual(main.connected(self.leftside,self.rightside,[1,0]),True)
        self.assertEqual(main.connected(self.rightside,self.leftside,[-1,0]),True)
        self.assertEqual(main.connected(self.leftside,self.rightside,[-1,0]),False)
        
        self.assertEqual(main.connected(self.downside,self.upside,[0,1]),True)
        self.assertEqual(main.connected(self.upside,self.downside,[0,-1]),True)
        self.assertEqual(main.connected(self.downside,self.upside,[1,0]),False)
        
        self.assertEqual(main.connected(self.upside,self.rightside,[0,1]),False)
        self.assertEqual(main.connected(self.rightside,self.upside,[-1,0]),True)
        
if __name__ == '__main__':
    unittest.main()
